﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI
	Private TileMap As X2TileMap
	Public RightDown, LeftDown, UpDown, DownDown As Boolean
	Public lblStats As B4XView
	Public world As B2World
	Private ivForeground As B4XView
	Private ivBackground As B4XView
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (parent As B4XView)
	parent.LoadLayout("main")
	world.Initialize("world", world.CreateVec2(0, -10))
	X2.Initialize(Me, ivForeground, world)
	'Configure the dimensions.
	X2.ConfigureDimensions(world.CreateVec2(10, 10), 10)
	TileMap.Initialize(X2, File.DirAssets, "minemap.json", ivBackground)
	TileMap.SetSingleTileDimensionsInMeters(0.35, 0.35)
	lblStats.TextColor = xui.Color_Blue
	'comment to disable debug drawing
	'X2.EnableDebugDraw
	'CreateMiniMap
	TileMap.PrepareObjectsDef("OL")
	Dim layer As X2ObjectsLayer = TileMap.Layers.Get("OL")
	For Each template As X2TileObjectTemplate In layer.ObjectsById.Values
		TileMap.CreateObject(template)
	Next
	'ivMiniMapBC.Initialize(ivMiniMap.Width / xui.Scale, ivMiniMap.Height / xui.Scale)
	
End Sub

Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	TileMap.DrawingComplete
	'X2.SetBitmapWithFitOrFill(ivMiniMap, ivMiniMapBC.Bitmap)
End Sub

'Return True to stop the game loop
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub

Public Sub Tick (GS As X2GameStep)
	HandleKeys (GS)
	If TileMap.DrawScreen(Array("Tile Layer 1"), X2.gs.DrawingTasks) Then
		'DrawMiniMap(GS)
	End If
End Sub

Private Sub HandleKeys (GS As X2GameStep)
	Dim v As B2Vec2 = X2.ScreenAABB.Center
	Dim delta As Float = X2.TimeStepMs / 100
	If RightDown Then
		v.X = v.X + delta
	Else If LeftDown Then
		v.X = v.X - delta
	End If
	If UpDown Then
		v.Y = v.y + delta
	Else If DownDown Then
		v.y = v.y - delta
	End If
	If v.Equals(X2.ScreenAABB.Center) = False Then
		X2.UpdateWorldCenter(v)
	End If
End Sub
